#!/bin/bash 

# TBD: Is this needed?
idir=${RPM_INSTALL_PREFIX}
if [ "${idir:${#idir}-1}" = "/" ]; then
	export RPM_INSTALL_PREFIX=$idir
else
	export RPM_INSTALL_PREFIX="${idir}/"
fi

echo "Checking ${RPM_INSTALL_PREFIX}..."
# TBD: Is this needed?
if [ -d ${RPM_INSTALL_PREFIX} ] ; then
 touch ${RPM_INSTALL_PREFIX}.test >/dev/null 2>&1
 status=$?
 if [ $status != 0 ] ; then
  echo "ERROR: ${RPM_INSTALL_PREFIX} exists and is not writable."
  exit 1
 fi
 /bin/rm ${RPM_INSTALL_PREFIX}.test
else
 mkdir -p ${RPM_INSTALL_PREFIX} >/dev/null 2>&1
 status=$?
 if [ $status != 0 ] ; then
  echo "ERROR: can not create ${RPM_INSTALL_PREFIX}."
  exit 1
 fi
fi

# Use UNPROTO_SCRIPT to replace @@@vars@@@ by ${UNPROTO_VARS} :
UNPROTO_SCRIPT="${RPM_INSTALL_PREFIX}/etc/squid/unproto.sh"
DO_RM_PROTO=0
# the script         the X.proto file, for X file                                 	rm? 			mode vars to be unprotod
#################### ############################################################ 	############ 	#### ###################
${UNPROTO_SCRIPT} ${RPM_INSTALL_PREFIX}usr/sbin/fn-local-squid.sh.proto 			$DO_RM_PROTO	755 ${UNPROTO_VARS}
if [ ! -s /etc/squid/customize.sh ];then
	${UNPROTO_SCRIPT} /etc/squid/customize.sh.proto									$DO_RM_PROTO	755 ${UNPROTO_VARS}
fi
${UNPROTO_SCRIPT} /etc/squid/init.d/frontier-squid.sh.proto 						$DO_RM_PROTO	755 ${UNPROTO_VARS}
/bin/cp -f /etc/squid/squid.conf.proto /etc/squid/squid.conf.frontierdefault.proto
${UNPROTO_SCRIPT} /etc/squid/squid.conf.frontierdefault.proto 						$DO_RM_PROTO	644 ${UNPROTO_VARS}
${UNPROTO_SCRIPT} ${RPM_INSTALL_PREFIX}etc/squid/cron/daily.sh.proto 				$DO_RM_PROTO	755 ${UNPROTO_VARS}
${UNPROTO_SCRIPT} ${RPM_INSTALL_PREFIX}etc/squid/cron/hourly.sh.proto 				$DO_RM_PROTO	755 ${UNPROTO_VARS}
${UNPROTO_SCRIPT} ${RPM_INSTALL_PREFIX}etc/squid/cron/crontab.dat.proto 			$DO_RM_PROTO	755 ${UNPROTO_VARS}

/bin/cat ${RPM_INSTALL_PREFIX}etc/squid/cron/crontab.dat
if [ -s /var/spool/cron/${FRONTIER_USER} ]; then
  sed -i '/etc\/squid\/cron\/daily.sh/d' /var/spool/cron/${FRONTIER_USER}
  sed -i '/etc\/squid\/cron\/hourly.sh/d' /var/spool/cron/${FRONTIER_USER}
fi
/bin/cat ${RPM_INSTALL_PREFIX}etc/squid/cron/crontab.dat >> /var/spool/cron/${FRONTIER_USER}
/bin/chown ${FRONTIER_USER}:${FRONTIER_GROUP} /var/spool/cron/${FRONTIER_USER}
/bin/chmod 600 /var/spool/cron/${FRONTIER_USER}

#	Setting ownership and mode
for i in etc/squid etc/squid/cron etc/squid/init.d ; do
  /bin/chown ${FRONTIER_USER}:${FRONTIER_GROUP} ${RPM_INSTALL_PREFIX}${i}
  /bin/chmod 755 ${RPM_INSTALL_PREFIX}${i}
done
#
mkdir -p ${CACHE_DIR} ${LOG_DIR} ${RUN_DIR}
install -o ${FRONTIER_USER} -g ${FRONTIER_GROUP} -d ${CACHE_DIR} ${LOG_DIR} ${RUN_DIR}
/bin/chmod 755  ${CACHE_DIR} ${RUN_DIR}
#
for i in \
	${RPM_INSTALL_PREFIX}usr/sbin/fn-local-squid.sh \
	${RPM_INSTALL_PREFIX}etc/squid/init.d/frontier-squid.sh \
	${RPM_INSTALL_PREFIX}etc/squid/cron/crontab.dat \
	${RPM_INSTALL_PREFIX}etc/squid/cron/daily.sh \
	${RPM_INSTALL_PREFIX}etc/squid/cron/hourly.sh \
	${RPM_INSTALL_PREFIX}etc/squid/customize.sh \
	${RPM_INSTALL_PREFIX}etc/squid/customhelps.awk \
;do
   /bin/chown ${FRONTIER_USER}:${FRONTIER_GROUP} ${i}
   /bin/chmod 755 ${i}
done

/bin/chmod 755 ${LOG_DIR}

/bin/chown ${FRONTIER_USER}:${FRONTIER_GROUP} /etc/squid/cachemgr.conf;
/bin/chmod 444 /etc/squid/cachemgr.conf;

#	Creating the cache
#
# TBD: I suspect that the following dir may be wrong? ${RPM_INSTALL_PREFIX}var/cache/squid 
#      In particular, CERN has its cache at /etc/squid_cache, not ${RPM_INSTALL_PREFIX}var/cache/squid
if [ ! -d ${RPM_INSTALL_PREFIX}var/cache/squid ]; then 
   echo "Initializing the squid cache"
   ${RPM_INSTALL_PREFIX}usr/sbin/squid -f /etc/squid/squid.conf -z ; 
fi

/bin/cp ${RPM_INSTALL_PREFIX}/etc/squid/init.d/frontier-squid.sh /etc/init.d/frontier-squid
/bin/chown root:root /etc/init.d/frontier-squid
/bin/chmod 755 /etc/init.d/frontier-squid
/sbin/chkconfig --add frontier-squid
/sbin/chkconfig frontier-squid on

# (stop and) start squid, depending on its status:
/sbin/service frontier-squid status
status=$?
if [ $status = 0 ] ; then # running
  /sbin/service frontier-squid stop
fi
/sbin/service frontier-squid start

status=$?
if [ $status != 0 ] ; then
  echo "ERROR: frontier-squid (re)start failed"
  exit 1
fi

